---
title:  "Media recap of the Apache Beam graduation"
date:   2017-02-01 00:00:01 -0800
categories:
  - blog
aliases:
  - /blog/2017/02/01/graduation-media-recap.html
authors:
  - davor
---
<!--
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->

One year ago today Apache Beam was accepted into incubation at the Apache
Software Foundation. The community's work over the past year culminated, just
over three weeks ago, with an [announcement](/blog/2017/01/10/beam-graduates.html)
that Apache Beam has successfully graduated as a new Top-Level Project at the
foundation. Graduation sparked an additional interest in the project, from
corporate endorsements, news articles, interviews, to the volume of traffic to
our website and mailing lists.

<!--more-->

Corporate endorsements include Google, PayPal, Talend, data Artisans, and
others. You can read more in the following blog posts:
* Google: "[Apache Beam graduates to a top-level project](https://opensource.googleblog.com/2017/01/apache-beam-graduates.html)" by Tyler Akidau.
* Talend: "[The Future of Apache Beam, Now a Top-Level Apache Software Foundation Project](https://www.talend.com/blog/2017/01/13/future-apache-beam-now-top-level-apache-software-foundation-project/)" by Jean-Baptiste Onofré.
* Talend: "[Apache Beam Your Way to Greater Data Agility](https://www.talend.com/blog/2017/01/23/apache-beam-way-greater-data-agility/?utm_medium=socialpost&utm_source=twitter&utm_campaign=blog)" by Shane Kent.
* Google: "[Apache Beam graduates from incubation: Try it today on Google Cloud Dataflow](https://cloud.google.com/blog/big-data/2017/01/apache-beam-graduates-from-incubation-try-it-today-on-google-cloud-dataflow)" by Frances Perry.

News coverage started with the Apache Software Foundation’s press release in
[Nasdaq GlobeNewswire](https://globenewswire.com/news-release/2017/01/10/904692/0/en/The-Apache-Software-Foundation-Announces-Apache-Beam-as-a-Top-Level-Project.html),
and followed by coverage in many independent outlets. Some of those in English
include:
* ZDNet: "[Apache Beam and Spark: New coopetition for squashing the Lambda Architecture?](https://www.zdnet.com/article/apache-beam-and-spark-new-coopetition-for-squashing-the-lambda-architecture/)" by Tony Baer.
* Datanami: "[Google Lauds Outside Influence on Apache Beam](https://www.datanami.com/2017/01/10/google-lauds-outside-influence-apache-beam/)" by Alex Woodie.
* InfoWorld / JavaWorld: "[Apache Beam unifies batch and streaming for big data](https://www.infoworld.com/article/3156598/big-data/apache-beam-unifies-batch-and-streaming-for-big-data.html)" by Serdar Yegulalp, and republished in [JavaWorld](https://www.javaworld.com/article/3156598/big-data/apache-beam-unifies-batch-and-streaming-for-big-data.html).
* JAXenter: "[In a way, Apache Beam is the glue that connects many big data systems together](https://jaxenter.com/apache-beam-interview-131314.html)" by Kypriani Sinaris.
* OStatic: "Apache Beam Unifies Batch and Streaming Data Processing" by Sam Dean. <!-- http://ostatic.com/blog/apache-beam-unifies-batch-and-streaming-data-processing -->
* Enterprise Apps Today: "[Apache Beam Graduates to Help Define Streaming Data Processing](http://www.enterpriseappstoday.com/business-intelligence/data-analytics/apache-beam-graduates-to-help-define-streaming-data-processing.html)" by Sean Michael Kerner.
* The Register: "[Google must be Beaming as Apache announces its new top-level projects](https://www.theregister.co.uk/2017/01/10/google_must_be_ibeamiing_as_apache_announces_its_new_top_level_projects/)" by Alexander J. Martin.
* SiliconANGLE: "[Apache Software Foundation announces two more top-level open source projects](https://siliconangle.com/blog/2017/01/11/apache-software-foundation-announces-2-top-level-projects/)" by Mike Wheatley.
* SD Times: "[Apache Beam goes top level](https://sdtimes.com/apache-beam-goes-top-level/)" by Alex Handy.

Graduation and media coverage helped push Beam website traffic to record levels.
The website traffic, measured in unique sessions per hour, peaked at more than
15 times above the previous week’s numbers. In a steady state, the traffic is
several times larger than before graduation.

Hopefully these perspectives entice you to join us on this exciting ride, either
as a user or a contributor, as we work towards our first release with API
stability. If you’d like to try out Apache Beam today, check out the latest
[0.4.0 release](/get-started/downloads/). We welcome
contribution and participation from anyone through our mailing lists, issue
tracker, pull requests, and events.
